"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .productpricerecurringinterval import ProductPriceRecurringInterval
from datetime import datetime
from enum import Enum
from polar_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import Final, TypedDict
from typing_extensions import Annotated


class ProductPriceRecurringType(str, Enum):
    r"""The type of the price."""
    RECURRING = "recurring"

class ProductPriceRecurringTypedDict(TypedDict):
    r"""A recurring price for a product, i.e. a subscription."""
    
    created_at: datetime
    r"""Creation timestamp of the object."""
    modified_at: Nullable[datetime]
    r"""Last modification timestamp of the object."""
    id: str
    r"""The ID of the price."""
    price_amount: int
    r"""The price in cents."""
    price_currency: str
    r"""The currency."""
    is_archived: bool
    r"""Whether the price is archived and no longer available."""
    recurring_interval: Nullable[ProductPriceRecurringInterval]
    r"""The recurring interval of the price, if type is `recurring`."""
    

class ProductPriceRecurring(BaseModel):
    r"""A recurring price for a product, i.e. a subscription."""
    
    created_at: datetime
    r"""Creation timestamp of the object."""
    modified_at: Nullable[datetime]
    r"""Last modification timestamp of the object."""
    id: str
    r"""The ID of the price."""
    price_amount: int
    r"""The price in cents."""
    price_currency: str
    r"""The currency."""
    is_archived: bool
    r"""Whether the price is archived and no longer available."""
    recurring_interval: Nullable[ProductPriceRecurringInterval]
    r"""The recurring interval of the price, if type is `recurring`."""
    TYPE: Annotated[Final[ProductPriceRecurringType], pydantic.Field(alias="type")] = ProductPriceRecurringType.RECURRING # type: ignore
    r"""The type of the price."""
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["modified_at", "recurring_interval"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
        
