"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .productpricerecurringcreate import ProductPriceRecurringCreate, ProductPriceRecurringCreateTypedDict
from enum import Enum
from polar_sdk.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired, deprecated


@deprecated("warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible.")
class ProductRecurringCreateType(str, Enum):
    INDIVIDUAL = "individual"
    BUSINESS = "business"

class ProductRecurringCreateTypedDict(TypedDict):
    r"""Schema to create a recurring product, i.e. a subscription."""
    
    name: str
    r"""The name of the product."""
    prices: List[ProductPriceRecurringCreateTypedDict]
    r"""List of available prices for this product."""
    type: ProductRecurringCreateType
    description: NotRequired[Nullable[str]]
    r"""The description of the product."""
    medias: NotRequired[Nullable[List[str]]]
    r"""List of file IDs. Each one must be on the same organization as the product, of type `product_media` and correctly uploaded."""
    organization_id: NotRequired[Nullable[str]]
    r"""The ID of the organization owning the product. **Required unless you use an organization token.**"""
    is_highlighted: NotRequired[bool]
    

class ProductRecurringCreate(BaseModel):
    r"""Schema to create a recurring product, i.e. a subscription."""
    
    name: str
    r"""The name of the product."""
    prices: List[ProductPriceRecurringCreate]
    r"""List of available prices for this product."""
    type: Annotated[ProductRecurringCreateType, pydantic.Field(deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible.")]
    description: OptionalNullable[str] = UNSET
    r"""The description of the product."""
    medias: OptionalNullable[List[str]] = UNSET
    r"""List of file IDs. Each one must be on the same organization as the product, of type `product_media` and correctly uploaded."""
    organization_id: OptionalNullable[str] = UNSET
    r"""The ID of the organization owning the product. **Required unless you use an organization token.**"""
    is_highlighted: Annotated[Optional[bool], pydantic.Field(deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible.")] = False
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["description", "medias", "organization_id", "is_highlighted"]
        nullable_fields = ["description", "medias", "organization_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
        
